// ignore_for_file: constant_identifier_names

import 'package:sis_flutter/models/models.dart';

class PrioridadesPersonaResponse extends Basico {
  final List<Detalle> detalle;

  PrioridadesPersonaResponse({
    required this.detalle,
  });
}

class Detalle extends Basico {
  final String? nombre;
  final String? avance;
  final List<Tarea>? tareas;
  final int? prioridad;
  final String? nombreProyecto;
  final String? idProyecto;

  Detalle({
    super.id,
    this.nombre,
    this.avance,
    this.tareas,
    this.prioridad,
    this.nombreProyecto,
    this.idProyecto,
  });

  factory Detalle.fromJson(Map<String, dynamic> json) {
    return Detalle(
      id: Basico.parseString(json["id"]),
      nombre: Basico.parseString(json["nombre"]),
      avance: Basico.parseString(json["avance"]),
      tareas: (json["tareasPendientes"] as List)
          .map((e) => Tarea.fromJson(e))
          .toList()
          .cast(),
      prioridad: Basico.parseInt(json["prioridad"]),
      nombreProyecto: Basico.parseString(json["nombreProyecto"]),
      idProyecto: Basico.parseString(json["idProyecto"]),
    );
  }
}

class Tarea extends Basico {
  final int? idActividad;
  final String? idUsuario;
  final String? contenido;
  final String? idTareaPadre;
  final DateTime? terminado;
  final int? posicion;
  final String? urgencia;
  final String? idCreador;
  final String? testing;
  final String? iops;
  final String? soporte;
  final int? prioridad;

  Tarea({
    super.id,
    super.creado,
    super.idLocal,
    super.eliminado,
    super.modificado,
    this.idActividad,
    this.idUsuario,
    this.contenido,
    this.idTareaPadre,
    this.terminado,
    this.posicion,
    this.urgencia,
    this.idCreador,
    this.testing,
    this.iops,
    this.soporte,
    this.prioridad,
  });

  factory Tarea.fromJson(Map<String, dynamic> json) {
    return Tarea(
      id: Basico.parseString("${json["id"]}"),
      idActividad: Basico.parseInt(json["id_actividad"]),
      idUsuario: Basico.parseString(json["id_usuario"]),
      contenido: Basico.parseString(json["contenido"]),
      idTareaPadre: Basico.parseString(json["id_tarea_padre"]),
      terminado: Basico.parseDate(json["terminado"]),
      posicion: Basico.parseInt(json["posicion"]),
      urgencia: Basico.parseString(json["urgencia"]),
      creado: Basico.parseDate(json["creado"]),
      eliminado: Basico.parseDate(json["eliminado"]),
      idCreador: Basico.parseString(json["idCreador"]),
      testing: Basico.parseString(json["testing"]),
      iops: Basico.parseString(json["iops"]),
      soporte: Basico.parseString(json["soporte"]),
      prioridad: Basico.parseInt(json["prioridad"]),
    );
  }

  // @override
  // Map<String, dynamic> toJson() => {
  //       "id": id,
  //       "id_actividad": idActividad,
  //       "id_usuario": idUsuario,
  //       "contenido": contenido,
  //       "id_tarea_padre": idTareaPadre,
  //       "terminado": terminado,
  //       "posicion": posicion,
  //       "urgencia": urgencia,
  //       "creado": creado,
  //       "eliminado": eliminado,
  //       "id_creador": idCreador,
  //       "testing": testing,
  //       "iops": iops,
  //       "soporte": soporte,
  //       "prioridad": prioridad,
  //     };
}

enum IdCreador {
  F37_BCVRLNFRDHCH,
  THE_38_L81_SK35_CNDGB2,
  THE_4_MGE9_AJMCDM6_ASV
}

enum Iops { DEFAULT }
