import 'dart:convert';

import 'package:sis_flutter/data/api_response.dart';
import 'package:sis_flutter/models/tarea_model.dart';
import 'package:sis_flutter/services/base_service.dart';

class PrioridadesService extends BaseService {
  final endpoint = "/v1/actividad/prioridades";

  Future<List<Tarea>> getPrioridades(String idUsuario) async {
    var r = await get(endpoint, headers: {
      'Content-Type': 'application/json'
    }, queryParameters: {
      'usuario': idUsuario,
    });

    var body = jsonDecode(r.body);
    var detalle = (body['detalle'] as List<dynamic>)
        .cast<Map<String, dynamic>>()
        .toList();

    final List<Tarea> prioridades = [];
    if (r.statusCode == 200) {
      for (var i in detalle) {
        Tarea tareasPendiente = Tarea.fromJson(i);
        prioridades.add(tareasPendiente);
      }
    }

    return prioridades;
  }

  Future<List<Detalle>> getDetalle(String idUsuario) async {
    var r = await get(endpoint, headers: {
      'Content-Type': 'application/json'
    }, queryParameters: {
      'usuario': idUsuario,
    });

    var body = jsonDecode(r.body);
    var detalle = (body['detalle'] as List<dynamic>)
        .cast<Map<String, dynamic>>()
        .toList();

    final List<Detalle> prioridades = [];
    if (r.statusCode == 200) {
      for (var i in detalle) {
        Detalle detalle = Detalle.fromJson(i);
        prioridades.add(detalle);
      }
    }

    return prioridades;
  }
}
