import 'package:flutter/material.dart';

import 'package:sis_flutter/models/tarea_model.dart';
import 'package:sis_flutter/services/tarea_service.dart';

class PrioridadesViewMode extends ChangeNotifier {
  List<Tarea> _prioridades = [];
  List<Tarea> get prioridades => _prioridades;

  List<Detalle> _detalle = [];
  List<Detalle> get detalle => _detalle;

  Future<List<Tarea>> fetchPriodidades(idUsuario) async {
    final prioridadesdata =
        await PrioridadesService().getPrioridades(idUsuario);
    _prioridades = prioridadesdata;
    notifyListeners();
    return _prioridades;
  }

  Future<List<Detalle>> fetchDetalle(idUsuario) async {
    final detalledata = await PrioridadesService().getDetalle(idUsuario);
    _detalle = detalledata;
    notifyListeners();
    return _detalle;
  }
}
